import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourTourismProjectTravelNotes from '@/types/table/tourTourismProjectTravelNotes';
import { TourTourismTravelNotesFileData } from '@/api/generated/tourTourismTravelNotesFileController';
import { TourTourismTravelNotesContentData } from '@/api/generated/tourTourismTravelNotesContentController';
import { TourismProjectData } from '@/api/generated/tourismProjectController';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourTourismProjectTravelNotesData extends TourTourismProjectTravelNotes {
  tourTourismTravelNotesFile?: TourTourismTravelNotesFileData;
  tourTourismTravelNotesContent?: TourTourismTravelNotesContentData;
  tourismProjectList?: TourismProjectData[];
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourTourismProjectTravelNotesController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourTourismProjectTravelNotesData>>(API_CONTEXT + '/app/tourTourismProjectTravelNotes/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourTourismProjectTravelNotesData>(API_CONTEXT + '/app/tourTourismProjectTravelNotes/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourTourismProjectTravelNotes/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourTourismProjectTravelNotes/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourTourismProjectTravelNotes/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/deleteBatch', params, httpOptions);
  }
  static listTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/listTourTravelNotesProjectRelation', params, httpOptions);
  }
  static listNotInTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/listNotInTourTravelNotesProjectRelation', params, httpOptions);
  }
  static addTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/addTourTravelNotesProjectRelation', params, httpOptions);
  }
  static deleteTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/deleteTourTravelNotesProjectRelation', params, httpOptions);
  }
  static deleteTourTravelNotesProjectRelationList(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/deleteTourTravelNotesProjectRelationList', params, httpOptions);
  }
  static updateTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTourismProjectTravelNotes/updateTourTravelNotesProjectRelation', params, httpOptions);
  }
  static viewTourTravelNotesProjectRelation(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get(API_CONTEXT + '/app/tourTourismProjectTravelNotes/viewTourTravelNotesProjectRelation', params, httpOptions);
  }
  static updateIsOriginalChange(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/extra/updateIsOriginalChange', params, httpOptions);
  }
}